.\" -*-nroff-*-
.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "0.05",
.\"     date            = "14 May 2013",
.\"     time            = "06:16:13 MDT",
.\"     filename        = "bibsql.man",
.\"     address         = "University of Utah
.\"                        Department of Mathematics, 110 LCB
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 581 4148",
.\"     URL             = "http://www.math.utah.edu/~beebe",
.\"     checksum        = "64832 1599 6337 45602",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@computer.org (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "",
.\"     license         = "GNU General Public License (version 2 or
.\"                        later)",
.\"     supported       = "yes",
.\"     docstring       = "The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.\"
.if t .ds Bi B\s-2IB\s+2T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Bi BibTeX
.\"
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.\"
.\"=====================================================================
.TH BIBSQL 1 "13 May 2013" "Version 0.05"
.\"=====================================================================
.SH NAME
bibsql \- search an SQL (Structured Query Language) database of BibTeX data
.\"=====================================================================
.SH SYNOPSIS
.B bibsql
.\"-----------------------------------------------
.RB [ \-\-author ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-command
.IR " 'command1; command2; .\|.\|.'" ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-database
.IR dbname ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-help ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-host
.IR name ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-options
.IR " '.\|.\|. server options .\|.\|.'" ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-quiet ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-server
.IR "[ MySQL | psql | PostgreSQL | SQLite ]" ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-user
.IR dbuser ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.RB [ \-\-version ]
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.IR "< infile" " or " " bibfile1 bibfile2 bibfile3 .\|.\|."
.\"-----------------------------------------------
.if n .ti +7n
.if t .ti +\w'\fBbibsql\fP\ 'u
.IR "> outfile"
.\"=====================================================================
.SH DESCRIPTION
.B bibsql
is an interface to SQL (Structured Query Language)
client programs for searching an SQL database
previously created from the conversion of
\*(Bi\& data by
.BR bibtosql (1).
The manual pages of that program describe the
format of the SQL tables that contain the \*(Bi\&
data, and some of that description is paraphrased
later in the
.B "DETAILED DESCRIPTION"
section.
.PP
Once the SQL database has been created with the
help
of
.BR bibtosql (1),
starting
.B bibsql
and issuing queries is relatively quick: search
responses can be produced in a fraction of a
second on modern personal and office computers,
even for a database with a million or so entries.
.\"=====================================================================
.SH OPTIONS
Command-line options may be abbreviated to a
unique leading prefix, and lettercase is
.I not
significant.
.PP
The leading hyphen that distinguishes an option
from a filename may be doubled, for compatibility
with GNU and POSIX conventions.  Thus,
.BR \-a ,
.BR \-author
and
.B \-\-author
are equivalent.
.PP
.\"-----------------------------------------------
.TP \w'\-database'u+3n
.B \-\-author
Display an author credit on
.IR stdout ,
and then terminate with a success return code.
.\"-----------------------------------------------
.TP
.BI \-\-command " 'command1; command2; .\|.\|.'"
Specify one or more SQL commands to be executed in
batch mode, after which, the program terminates
with a success return code.  Batch mode suppresses
status messages and table headers and footers.
.\"-----------------------------------------------
.TP
.BI \-\-database " name of \*(Bi\& database"
Specify the name to be used for the database in
the SQL system.  The default name is
.IR bibtex ,
and to avoid user confusion, it is recommended
that the name be changed only for database
experiments.
.\"-----------------------------------------------
.TP
.B \-\-help
Display a help message on
.IR stdout ,
giving a usage description, similar to this
section of the manual pages, and then terminate
with a success return code.  This option may be
abbreviated
.B \-\-h
or 
.B \-h
or
.BR \-? .
.\"-----------------------------------------------
.TP
.B \-\-host
Specify an alternate SQL server hostname to
override the default one chosen according to the
database name.  This option may be abbreviated
.B \-\-ho
or 
.B \-ho.
.\"-----------------------------------------------
.TP
.BI \-\-options " '.\|.\|. server options .\|.\|.'"
Specify additional options to be passed verbatim
to the SQL server.
.IP
For example, with a nondefault database user name,
a MySQL server might require a
.B \-p
option to request that a password prompt be
issued.
.\"-----------------------------------------------
.TP
.B \-\-quiet
Suppress startup greeting and description of SQL
searching.
.\"-----------------------------------------------
.TP
.BI \-\-server " [ MySQL | psql | PostgreSQL | SQLite ]"
Select the database server type for which input is to
be prepared (default:
.IR SQLite ).
.IP
The name
.I psql
is an alias for
.IR PostgreSQL ,
since the former is the name of the client program
on many systems.
.IP
The name may be abbreviated to any unique leading
prefix, and its lettercase is
.I not
significant.
.IP
Although the input formats of the supported SQL
systems are similar, there are important small
differences that make it imperative to identify
the target system.
.\"-----------------------------------------------
.TP
.BI \-\-user " name of database user"
Specify the user name with access rights to the
SQL database.  The default user name is
.IR reader ,
which gives read-only access to the database.
.IP
This name is unrelated to the Unix login name.
.IP
This option exists primarily for experimentation
and database management, and should rarely be
needed.
.\"-----------------------------------------------
.TP
.B \-\-version
Display the program version number and release
date on
.I stdout
and then terminate with a success return code.
.\"=====================================================================
.SH "DETAILED DESCRIPTION"
The
.I bibtab
table contains \*(Bi\& document entries with these
column names:
.RS
\&\fCauthorcount,
editorcount,
pagecount,
bibtype,
filename,
label,
author,
editor,
booktitle,
title,
crossref,
chapter,
journal,
volume,
type,
number,
institution,
organization,
publisher,
school,
address,
edition,
pages,
day,
month,
monthnumber,
year,
CODEN,
DOI,
ISBN,
ISBN13,
ISSN,
ISSNL,
LCCN,
MRclass,
MRnumber,
MRreviewer,
bibdate,
bibsource,
bibtimestamp,
note,
series,
URL,
abstract,
fjournal,
keywords,
language,
remark,
subject,
TOC,
ZMnumber,
acknowledgement,
advisor,
affiliation,
affiliationaddress,
ajournal,
annote,
articleno,
authordates,
bookDOI,
bookURL,
bookpages,
classcodes,
corpsource,
editordates,
howpublished,
institution,
journalURL,
journalabr,
key,
onlinedate,
remark,
reviewer,
subjectdates,
thesaurus,
treatment,
ZMclass,
entry.\fP
.RE
The first three
.I count
columns in the
.I bibtab
table are integers.  All of the remaining columns
are variable-length strings whose maximum length
is at least 65,536 characters.
.PP
The
.I namtab
table contains author and editor names with
these columns:
.RS
\&\fCname, count.\fP
.RE
The count column records the number of occurrences
of the name.
.PP
The
.I strtab
table contains \*(Bi\& \&\fC@String{key =
value}\fP definitions with these columns:
.RS
\&\fCkey, value, entry.\fP
.RE
.PP
In the tables, the \&\fCentry\fP column contains
the original \*(Bi\& entry,
.I exactly
as it was input to
.BR bibtosql (1).
.PP
Except in the \&\fCentry\fP column, consecutive
whitespace is reduced to a single space, \*(Te\&
macros are simplified or removed, and \*(Te\&
accents and braces are stripped from key values.
That convention makes specification of search
strings for key values easier.  Thus, to search
for \&\fCPaul Erd{\eH{o}}s\fP, use the pattern
\&\fC%P%Erdos%\fP.  To find documents with
\&\fC{\eTeX}book\fP or \&\fC\eTeX{}book\fP or
\&\fC\eTeX book\fP in their titles, use the
pattern \&\fC%texbook%\fP.  Search patterns are
described in the next section.
.PP
Indeterminate, unknown, or unset values are
recorded as NULL, so as to facilitate their
exclusion in later searches.
.PP
NULL values are never used in string comparisons
or in numeric expressions, or in built-in
functions that operate on strings or numbers.
Thus, if you take the sum or average of a
numerical column, only rows with numbers in them
participate.
.PP
The expressions \&\fIcolumn\fP \&\fCIS NULL\fP and
\&\fIcolumn\fP \&\fCIS NOT NULL\fP test for the
presence or absence of a NULL value.
.PP
While most of the key names in the \&\fIbibtab\fP
table are standard ones in \*(Bi\&, a few are
not. They include
.\"-----------------------------------------------
.TP \w'\(bu'u+2n
\(bu
\&\fCCODEN\fP (Chemical Abstracts
.I "CODE Name"
for serial publications).
.\"-----------------------------------------------
.TP
\(bu
\&\fCDOI\fP
.RI ( "Digital Object Identifier",
a
.I "unique and permanent"
name for the master copy of an electronic
document).  If it does not look like an Internet
URL, convert it to one by prefixing it with
\&\fChttp://dx.doi.org/\fP.
.\"-----------------------------------------------
.TP
\(bu
\&\fCISSN\fP
.RI ( "International Standard Serial Number" :
eight digits, optionally written as two groups of
four digits separated by a hyphen).
.\"-----------------------------------------------
.TP
\(bu
\&\fCISBN\fP (old-style
.IR "International Standard Book Number" :
10 digits, the last of which may be
.I X
or
.IR x ).
Optional hyphens separate it into four digit
groups that define the country or language,
publisher, book number, and a final check digit
for error detection.
.\"-----------------------------------------------
.TP
\(bu
\&\fCISBN13\fP (new-style (since 2007)
.IR "International Standard Book Number" :
13 digits, the last of which may be
.I X
or
.IR x ).
This contains the old ten-digit ISBN, with a new
prefix of \&\fC978-\fP, and a revised check digit.
When the supply of unused ISBNs is exhausted, a
new prefix \&\fC979-\fP will be assigned, and such
numbers will then not be convertible to the
old ten-digit form.
.\"-----------------------------------------------
.TP
\(bu
\&\fCLCCN\fP (US
.IR "Library of Congress Catalog Number" ),
used for book identification at many US libraries,
and at some libraries in other countries.
.\"-----------------------------------------------
.TP
\(bu
\&\fCMRclass\fP (list of American Mathematical
Society
.I "Math Reviews"
five-character subject classification codes).
.\"-----------------------------------------------
.TP
\(bu
\&\fCMRnumber\fP
.RI ( "Math Reviews" " database number)."
.\"-----------------------------------------------
.TP
\(bu
\&\fCMRreviewer\fP
.RI ( "Math Reviews" " reviewer name)."
.\"-----------------------------------------------
.TP
\(bu
\&\fCbibdate\fP (Unix
.BR date (1)
string in the formats \&\fCSat Oct 25 20:15:00 MDT
2008\fP or \&\fCSat Oct 25 20:15:00 2008\fP; it
records a timestamp of the last significant change to
the \*(Bi\& entry data).
.\"-----------------------------------------------
.TP
\(bu
\&\fCbibsource\fP (arbitrary text indicating
source(s) of bibliographic data, often as a list of
Internet URLs or Z3950 library catalog addresses).
.\"-----------------------------------------------
.TP
\(bu
\&\fCbibtimestamp\fP (alternate representation of
\&\fCbibdate\fP value in the form \&\fC2008.10.25
20:15:00 MDT\fP, for which lexicographic sort
order is also time order).
.\"-----------------------------------------------
.TP
\(bu
\&\fCURL\fP (Internet
.I "Uniform Resource Locator(s)"
for retrieval of an electronic form of the
document).
.\"-----------------------------------------------
.TP
\(bu
\&\fCremark\fP (additional commentary about the
entry that is not intended to be included in a
typeset reference list).
.\"-----------------------------------------------
.TP
\(bu
\&\fCsubject\fP (subject classification phrases).
.\"-----------------------------------------------
.TP
\(bu
\&\fCTOC\fP (table of contents of the publication).
.\"-----------------------------------------------
.TP
\(bu
\&\fCZMnumber\fP (European Mathematical Society
.I "Zeitschrift fuer Mathematik"
database number).
.\"=====================================================================
.SH "SQL SEARCH TUTORIAL"
The
.IR "Structured Query Language" ,
SQL, is a system that allows relational database
lookups to be carried out according to an
imperative English-like grammar that is
nevertheless precise enough to allow unambiguous
interpretation by computer software.
.PP
The acronym SQL is commonly pronounced either as
its letters
.RI ( "ess cue ell" ),
or like the name
.IR sequel .
.PP
SQL is defined in several national, government,
international, and industry standards, including
ANSI (X3.168-1989, X3.135-1992, 9579-2-1993,
9075-3-1995, and 9075-4-1996), FIPS (127:1990,
127-2:1993, 193:1995), ISO/IEC (9075:1987,
9075:1989, 9075:1992, 9075:2003, and 13249:2007),
and X/Open (CAE 1994).  Many 2008-vintage SQL
systems claim conformance to most of the 1992 ISO
Standard.
.PP
Database technology has been well optimized since
the relational model was first proposed by
E. F. Codd in 1970, and rather complex queries can
usually be handled quickly by any SQL database.
While industrial-strength commercial database
systems capable of scaling to enormous sizes are
in worldwide use, there are at least three
freely-available SQL systems that are distributed
either under open-source licenses, or are in the
public domain:
.BR mySQL ,
.BR PostgreSQL ,
and
.BR SQLite .
.PP
Of the three, SQLite is to be recommended for the
small to medium bibliographic database
applications supported by
.BR bibtosql (1),
because it is highly portable across all common
desktop operating systems and CPU architectures,
its internal database formats are platform
independent and stored in a
.I single
host file, and importantly, it requires no special
system privileges to install or to operate.
.PP
Although the expansion of the acronym SQL suggests
that it describes a language that should be the
same for all modern databases, there are, alas,
small variations in syntax between different
systems.  In the following, we assume SQLite,
since it is likely to be the one most used with
.B bibtosql
and
.BR bibsql .
At the time of writing this, its executable program is
called
.BR sqlite3 .
.PP
It is important to observe that SQL is
.I not
a programming language: there are no variables, no
loops, no conditionals, and no user-defined
functions or procedures.  When programmability is
required, it is conventional to embed calls to an
SQL interface library, either in a high-level
compiled language like C, C++, C#, or Java, or in a
scripting language, such as JavaScript, Perl, PHP,
Python, or Ruby, all of which have SQLite module
interfaces.
.PP
Lettercase in SQL commands and keywords is not
significant.
.PP
Character strings in SQL are written with
surrounding single quotes, like this:
\&\fC'SQL'\fP.  Some SQL clients also support
quotation-mark delimiters, \&\fC"SQL"\fP.
.PP
To represent a single quote inside a string,
double it: \&\fC'O''Neil'\fP is the name
\&\fIO'Neil\fP.  In MySQL, use a backslash escape
instead: \&\fC'O\e'Neil'\fP.
.PP
Long strings can be
split into separate strings that are joined with
the double-bar concatenation operator.  For
example, these two expressions evaluate to the
same string:
.RS
.nf
\&\fC'Aloisius Baldwin Chadwick, IV'
\&'Aloisius ' || 'Baldwin ' || 'Chadwick, ' || 'IV'\fP
.fi
.RE
.PP
Comments in SQLite take two forms.  An Ada-style
double hyphen starts a remark that continues to
end of line or end of file, whichever comes first.
MySQL additionally requires that the double hyphen
be followed by at least one space to eliminate an
ambiguity in the SQL expression grammar.
Otherwise, C-style /* .\|.\. */ comments can span
one or more lines.  Comments cannot be nested, and
can appear inside commands anywhere that
whitespace can (except inside character strings).
.PP
To understand the basics of SQL search commands,
it is useful to view the database as a tabular
array of values, where the rows are indexed by
arbitrary (and unspecified) unique integer
numbers, and each column is named by a field name
given in \&\fCCREATE\fP and \&\fCINSERT\fP
commands.  The search task is then to narrow the
selection of records to just one or more cells of
the table by specifying constraints on the values
in the columns.
.PP
The format of the output depends on the database
system.  For SQLite, it can be set by a dotted
command described in the help system like this:
.RS
.nf
\&\fC
\&.mode MODE ?TABLE?  Set output mode where MODE is one of:
                      csv    Comma-separated values
                      column Left-aligned columns.  (See .width)
                      html   HTML <table> code
                      insert SQL insert statements for TABLE
                      line   One value per line
                      list   Values delimited by .separator string
                      tabs   Tab-separated values
                      tcl    TCL list elements

\&.nullvalue STRING   Print STRING in place of NULL values

\&.output FILENAME    Send output to FILENAME

\&.output stdout      Send output to the screen

\&.separator STRING   Change separator used by output mode and .import

\&.width NUM NUM ...  Set column widths for "column" mode\fP

.fi
.RE
The default is to separate cell values by
vertical bars, with each table row output on a
single line (unless the string data contain
linebreaks).  Examples are given later in this
section.  However, other output styles chosen by
the SQLite \&\fC.mode\fP command make it easy to
output the data in formats suitable for input to
other databases, spreadsheets, and Web pages.
.PP
The simplest query asks for a return of all
records, where the asterisk means all data, and a
final semicolon is required to terminate the
command:
.RS
.nf
\&\fBselect * from bibtab;\fP\fC
1||9|article|acm-turing-awards.bib|Perlis:1967:SAS|
Alan J. Perlis|||The Synthesis of Algorithmic Systems||
j-J-ACM|14||1|||||||1--9||jan|1|1967|JACOAH|
http://doi.acm.org/10.1145/321371.321372|||
0004-5411 OR 00045411|||||Mon Dec 05 19:37:58 1994||
1994.12.05 19:37:58 ???||||||This is the 1966 ACM
Turing Award Lecture, and the first award.||||
@Article{Perlis:1967:SAS,
  author =       "Alan J. Perlis",
  title =        "The Synthesis of Algorithmic Systems",
  journal =      j-J-ACM,
  volume =       "14",
  number =       "1",
  pages =        "1--9",
  month =        jan,
  year =         "1967",
  CODEN =        "JACOAH",
  DOI =          "http://doi.acm.org/10.1145/321371.321372",
  ISSN =         "0004-5411",
  bibdate =      "Mon Dec 05 19:37:58 1994",
  acknowledgement = ack-nhfb,
  remark =       "This is the 1966 ACM Turing Award Lecture, and the
		 first award.",
}
\&.\|.\|.\&\fP
.fi
.RE
Here, we wrapped the long first line for
readability, and showed only the first record
returned.  The order of records depends on the
database creation and update history, and is
unpredictable without further specifications.
.PP
Next, we limit the output to just three specified
columns, and further limit the selection with a
\&\fCWHERE\fP clause:
.RS
.nf
\&\fBselect year, author, title from bibtab
    where author like '%Perlis%'
    and year = '1967';\fP\fC
1967|Alan J. Perlis|The Synthesis of Algorithmic Systems
1967|B. A. Galler and A. J. Perlis|A proposal for definitions in ALGOL\fP
.fi
.RE
.PP
Because the command is long, we wrote it on
separate lines.
.PP
The \&\fCLIKE\fP keyword is followed by a string
wherein
.I percent
represents zero or more characters,
.I underscore
a single character, and, in SQLite, lettercase is
.IR ignored .
Use \&\fCNOT LIKE\fP to negate the comparison.  To
search for a literal percent or underscore, double
them in the search pattern.
.PP
To make string comparisons case sensitive in
SQLite, set a library option like this:
.RS
.B "pragma case_sensitive_like = on;"
.RE
Set it to \&\fCoff\fP to restore the default
behavior.  SQLite recognizes synonyms
\&\fCtrue\fP, \&\fCyes\fP, and \&\fC1\fP for
\&\fCon\fP, and \&\fCfalse\fP, \&\fCno\fP, and
\&\fC0\fP for \&\fCoff\fP.
.PP
There is also a \&\fCGLOB\fP keyword that uses
Unix pathname matching, where
.I asterisk
matches zero or more characters,
.I "question mark"
matches a single character, and lettercase is always
.IR significant .
Unfortunately, there is no standard support in
SQLite for regular-expression matching like that
provided by many other Unix tools and scripting
languages, and some other SQL systems.
.PP
We can also use string equality tests, but then the match
must be exact, including lettercase:
.RS
.nf
\&\fBselect year, author, title from bibtab
    where author = 'Alan J. Perlis'
    order by year;\fP\fC
1958|Alan J. Perlis|Announcement
1963|Alan J. Perlis|Computation's development critical to our society
1967|Alan J. Perlis|The Synthesis of Algorithmic Systems
1969|Alan J. Perlis|Introduction to extensible languages
1978|Alan J. Perlis|The American side of the development of Algol
1986|Alan J. Perlis|Two Thousand Words and Two Thousand Ideas --- The 650 at Carnegie\fP
.fi
.RE
.PP
In the \&\fBorder by\fP clause, the operand can be
a column name or an ordinal number: \&\fBorder by
1, 3 \fP sorts by the first column, and when that
column has the same values, by the third column.
.PP
Such a search is likely to miss many entries belonging to
alternate spellings of the selected author, such as these:
.RS
.nf
\&\fBselect year, author, title from bibtab
    where author = 'A. J. Perlis'
    order by year;\fP
\&\fC1964|A. J. Perlis|A format language
1964|A. J. Perlis|Programming of digital computers
1964|A. J. Perlis|How should ACM publish computer research?
1966|A. J. Perlis|A Forum on Algorithms: A new policy for algorithms?
1975|A. J. Perlis|Introduction to Computer Science
1981|A. J. Perlis|The American side of the development of ALGOL\fP
.fi
.RE
.PP
It also misses entries where Perlis is one of
multiple authors, since SQL string-equality tests
always compare against the full string values.
.PP
Use the \&\fCnamtab\fP table to find the
frequencies and variations of an author or editor
name in the database:
.RS
.nf
\&\fBselect count, name from namtab
    where name like '%Steele%'
    order by 1 desc;\fP
\&\fC15|Guy L. Steele Jr.
3|Guy L. Steele
2|Guy L. Steele, Jr.
1|G. L. Steele, Jr.
1|G. Steele\fP
.fi
.RE
.PP
A more complex query requests unique output from a
range of years, sorts the data in descending
order, and limits the number of records returned
by the command to just five:
.RS
.nf
\&\fBselect distinct year, author, title from bibtab
    where author like '%D%Knuth'
    and '1955' < year
    and year < '1970'
    order by year desc
    limit 5;\fP\fC
1969|Donald E. Knuth|Seminumerical Algorithms
1968|Donald E. Knuth|Very magic squares
1967|Donald E. Knuth|The Remaining Trouble Spots in ALGOL 60
1966|Donald E. Knuth|Errata: ``Additional comments on a problem in ...''
1966|Donald E. Knuth|Letter to the Editor: Additional comments on a ...\fP
.fi
.RE
.PP
Some SQL systems permit the quotes around the year
values to be omitted, but strictly, they are
strings, not integers, since they occasionally
contain a range or list of years.
.PP
The expression
.B "'1955' < year and year < '1970'"
can also be written as
.BR "year between '1956' and '1969'" :
the endpoints of the
.B between
operator are included in the range test.
.PP
When multiple logical operators are used in an
expression without disambiguating parentheses,
\&\fBand\fP is evaluated before \&\fBor\fP.  Thus,
\&\fBa and b or c and d\fP is treated as if it
were written \&\fB(a and b) or (c and d)\fP.
When in doubt about the meaning of a complex
expression, parenthesize!
.PP
The \&\fBselect\fP command can be used for
rudimentary expression evaluation in SQL, simply
by omitting cell selections.  Numerical
expressions are evaluated in floating-point
arithmetic if at least one of the operands
contains a decimal point:
.RS
.nf
\&\fBselect 'ABC' > 'DEF';\fP
\&\fC0\fP

\&\fBselect 'ABC' < 'ABCDEF';\fP
\&\fC1\fP

\&\fBselect 1.0 / 3.0;\fP
\&\fC0.333333333333333\fP

\&\fBselect 1.0 / 3;\fP
\&\fC0.333333333333333\fP

\&\fBselect 1 / 3;\fP
\&\fC0\fP
.fi
.RE
.PP
In the last example, 1/3 is treated as an integer
division, producing a zero result.
.PP
The larger SQL systems offer a wide range of
numerical and string functions, similar to those
of many programming languages.  However, SQLite
has only a minimal repertoire of built-in
functions.  Here are examples of some of the SQL
functions that can operate on the returned
results, including ones that just report counts,
averages, extrema, and sums:
.RS
.nf
\&\fBselect count(*) from bibtab;\fP
\&\fC417349\fP

\&\fBselect count(length(title)) from bibtab where length(title) > 250;\fP
\&\fC772\fP

\&\fBselect round(417349 / 772);\fP
\&\fC540.0\fP

\&\fBselect avg(length(title)) from bibtab where length(title) > 0;\fP
\&\fC61.3055823817683\fP

\&\fBselect max(length(title)) from bibtab;\fP
\&\fC1746\fP

\&\fBselect round(avg(pagecount)) from bibtab where pagecount > 0;\fP
\&\fC46.0\fP

\&\fBselect max(pagecount) from bibtab;\fP
\&\fC4412\fP

\&\fBselect max(editorcount) from bibtab;\fP
\&\fC18\fP

\&\fBselect max(authorcount) from bibtab;\fP
\&\fC115\fP

\&\fBselect max(authorcount) from bibtab where bibtype = 'book';\fP
\&\fC23\fP

\&\fBselect min(length(entry)) from bibtab;\fP
\&\fC101\fP

\&\fBselect max(length(entry)) from bibtab;\fP
\&\fC19269\fP

\&\fBselect avg(length(entry)) from bibtab;\fP
\&\fC770.447505564887\fP

\&\fBselect sum(pagecount) from bibtab where pagecount > 0;\fP
\&\fC13415587\fP

\&\fBselect distinct count(month), lower(month) from bibtab
       where length(month) = 3
       group by lower(month)
       order by cast(monthnumber as number);\fP
\&\fC19111|jan
15411|feb
20423|mar
19398|apr
17489|may
21585|jun
19537|jul
16577|aug
20039|sep
18896|oct
16859|nov
20924|dec\fP

\&\fBselect count(publisher), publisher from bibtab
    where length(publisher) > 0
    group by publisher
    order by count(publisher) desc
    limit 10;\fP
\&\fC5679|pub-SV
2154|pub-ORA
1820|pub-PROJECT-GUTENBERG
1593|pub-IEEE
1307|pub-AW
1076|pub-PH
891|pub-WILEY
838|pub-ACM
524|pub-PHPTR
425|pub-MCGRAW-HILL\fP

\&\fBselect count(journal), journal from bibtab
    where length(journal) > 0
    group by journal
    order by count(journal) desc
    limit 10;\fP
\&\fC60788|j-LECT-NOTES-COMP-SCI
14540|j-J-MATH-PHYS
9988|j-CACM
8594|j-APPL-MATH-COMP
7896|j-SIGPLAN
7253|j-LINEAR-ALGEBRA-APPL
6435|j-THEOR-COMP-SCI
5344|j-COMPUTER
5335|j-MATH-COMPUT
4974|j-INFO-PROC-LETT\fP

\&\fBselect count(*) from bibtab where authorcount > 0;\fP
406451

\&\fBselect round(100 * count(authorcount) / 406451), authorcount from bibtab
    where authorcount > 0
    group by authorcount
    order by count(authorcount) desc
    limit 5;\fP
\&\fC48.0|1
28.0|2
13.0|3
5.0|4
1.0|5\fP
.fi
.RE
.PP
The rule that NULL values are excluded from
consideration in expressions does not apply to the
special case of the \&\fCcount(*)\fP expression,
because it just counts rows, and no row is
completely NULL (recall that rows have hidden row
numbers).
.PP
Here, we discovered several facts about the bibliographic
data in this collection:
.RS
.TP \w'\(bu'u+2n
\(bu
There are 417\|349 unique \*(Bi\& entries.
.TP
\(bu
The longest title is 1746 characters, and 772 documents
(about 1 in 540) have titles longer than 250 characters.
.TP
\(bu
The average nonempty title is about 61 characters long.
.TP
\(bu
The average document page count is about 46 pages.
.TP
\(bu
The longest document has 4412 pages.
.TP
\(bu
There are no more than 18 editors or 115 authors of a single
document.
.TP
\(bu
No book entry has more than 23 authors.
.TP
\(bu
Entry lengths average about 770 characters, but range from
about 100 to almost 20\|000 characters.
.TP
\(bu
The documents described by the \*(Bi\& entries in the
database represent a corpus of more than 13.4 million pages.
.TP
\(bu
The last four searches are complex queries that
use the SQL \&\fCGROUP BY\fP feature to
simultaneously compute counts of publishers and
journals, producing a list of the top ten that
occur most frequently in the database, and do a
similar computation to find the percentage of
publications with one, two, .\|.\|.\|, five authors.
.RE
.PP
To avoid the need to first compute the count of
documents with authors, the last pair of queries
can be rephrased as a single command with an
embedded \&\fCSELECT\fP command, but we now make a
further restriction of the documents to count only
journal articles:
.RS
.nf
\&\fBselect round(100 * count(authorcount) /
             (select count(*) from bibtab
                     where authorcount > 0 and
                           bibtype = 'article')),
            authorcount
    from bibtab
    where authorcount > 0 and
          bibtype = 'article'
    group by authorcount
    order by count(authorcount) desc
    limit 5;\fP
\&\fC47.0|1
29.0|2
14.0|3
5.0|4
1.0|5\fP
.\" Another way, but CREATE VIEW is not discussed here:
.\" create view A as select * from bibtab where authorcount > 0 and bibtype = 'article';
.\" select round(100 * count(authorcount) / (select count(*) from A)) from A
.\" group by authorcount
.\" order by count(authorcount) desc
.\" limit 5;
.fi
.RE
.PP
\*(Bi\& string abbreviations are commonly used for
data that are repeated in many entries,
particularly for journals, institutions,
organizations, publishers, and addresses.  The
abbreviations can be retrieved from the
.I strtab
table with searches like these:
.RS
.nf
\&\fBselect entry from strtab where key like 'pub-WILEY%';\fP
\&\fC@String{pub-WILEY               = "Wiley"}
@String{pub-WILEY:adr           = "New York, NY, USA"}
@String{pub-WILEY-INTERSCIENCE  = "Wiley-In{\e-}ter{\e-}sci{\e-}ence"}
@String{pub-WILEY-INTERSCIENCE:adr = "New York, NY, USA"}\fP

\&\fBselect entry from strtab where value like '%Boston%' order by entry;\fP
\&\fC@String{pub-ALLYN-BACON:adr     = "Boston, MA, USA"}
@String{pub-AP-PROFESSIONAL:adr = "Boston, MA, USA"}
\&.\|.\|.
@String{pub-LITTLE-BROWN:adr    = "Boston, Toronto, London"}
@String{pub-MORGAN-KAUFMANN:adrbo = "Boston, MA, USA"}\fP

\&\fBselect count(value) from strtab where value like '%New York%';\fP
\&\fC59\fP

\&\fBselect distinct key from strtab where key like '%BIRK%' order by key;\fP
\&\fCpub-BIRKHAUSER
pub-BIRKHAUSER-BOSTON
pub-BIRKHAUSER-BOSTON:adr
pub-BIRKHAUSER:adr\fP
.fi
.RE
.PP
It is possible, although complex, to combine
searches in multiple tables to collect output data
from all of them.  Here is just one example, which
also introduces another SQL feature of providing
short aliases for database and table names within
a single query:
.RS
.nf
\&\fB.separator "\en"\fP

\&\fBselect s.entry, t.entry, b.entry
       from bibtab b, strtab s, strtab t
       where
           b.author like '%Robbins%'
       and b.author like '%Beebe%'
       and b.title like '%classic%'
       and b.publisher = s.key
       and b.address = t.key;\fP
\&\fC@String{pub-ORA-MEDIA           = "O'Reilly Media, Inc."}
@String{pub-ORA-MEDIA:adr       = "1005 Gravenstein Highway North,
                                   Sebastopol, CA 95472, USA"}

@Book{Robbins:2005:CSS,
  author =       "Arnold Robbins and Nelson H. F. Beebe",
  title =        "Classic Shell Scripting",
  publisher =    pub-ORA-MEDIA,
  address =      pub-ORA-MEDIA:adr,
  pages =        "xxii + 534",
  year =         "2005",
  ISBN =         "0-596-00595-4",
  ISBN-13 =      "978-0-596-00595-5",
  LCCN =         "QA76.76.O63 R633 2005",
  bibdate =      "Tue Jul 12 16:13:16 2005",
  URL =          "http://www.oreilly.com/catalog/shellsrptg/",
  acknowledgement = ack-nhfb,
}\fP
.fi
.RE
.PP
Changing the output separator to a newline
suppressed unwanted additional output, producing
output that can be copied directly into a \*(Bi\&
file.
.PP
Turn command-time reporting on or off like this:
.RS
.nf
.B ".timer on"
.B ".timer off"
.fi
.RE
.PP
To list the column fields in the SQLite database,
and to get further help, use the commands
.RS
.nf
.B ".schema bibtab"
.B ".help"
.fi
.RE
The output of \&\fC.schema\fP is similar to the
\&\fCCREATE TABLE\fP command shown in the manual
pages for
.BR bibtosql (1).
.PP
For more on the command syntax of SQLite, consult its Web
site documentation collection:
.RS
.nf
\&\fChttp://www.sqlite.org/docs.html\fP
.fi
.RE
There are hundreds of books on SQL, and many of them are
recorded in a \*(Bi\& bibliography available at this Web
location:
.RS
.nf
\&\fChttp://www.math.utah.edu/pub/tex/bib/sqlbooks.html\fP
.fi
.RE
.\"=====================================================================
.SH "MySQL NOTES"
Unlike SQLite, MySQL is a client/server database
system.  The biggest part of the software, and all
of the data, is on the server side, which can be
running on the same machine as the client, or
anywhere else as long as there is a network
connection between the two programs, and the
server allows connections from the client's
computer.  The client part is what the user
interacts with, and if desired, it can be hidden
behind a window interface or in a Web browser
script.  We do not do so with
.BR bibsql ,
because graphical interfaces generally destroy the
great power of user programmability.
.PP
The server attaches ownership and access
permissions to various parts of the data, and as a
result, setup and management are much more complex
compared to a simple system like SQLite.  Servers
can also make use of an advanced SQL feature
called
.IR triggers .
These are software routines that are invoked when
data are accessed or modified.  They can be used
for things like data validation, accounting, and
alerting management to unauthorized attempts to
access data.
.PP
After the
.B bibsql
script is installed, it may be necessary to make
minor edits to it to provide the information
needed to connect the clients to the servers: that
information is not standardized, and is strongly
site dependent.  Users of the script are
completely isolated from these issues.
.PP
In MySQL, \&\fCkey()\fP is a built-in function
whose name conflicts with a column name in the
\&\fCstrtab\fP table.  You can still use the
name, but it must be enclosed in back quotes:
.RS
.nf
.B "select `key` from strtab where `key` like '%WILEY%';"
.fi
.RE
.PP
Apart from this minor nuisance, all of the SQLite
command examples given earlier also work in MySQL,
except that the SQLite \&\fCGLOB\fP command is not
supported in MySQL.
.\" The CLIKE operator is documented in older
.\" MySQL literature, but at least in version 5.1
.\" (2008), LIKE is case INSENSITIVE, and CLIKE
.\" is not mentioned in the manual.
.\"
.\" , and the \&\fCLIKE\fP operator
.\" does
.\" .I not
.\" ignore lettercase.  However, MySQL also has a
.\" \&\fCCLIKE\fP operator that is case insensitive.
.PP
Conventional Unix-style regular-expression
matching is available in MySQL with the
\&\fCREGEXP\fP operator, like this:
.RS
.nf
\&\fBselect year, author from bibtab where author regexp 'Sh[ae]r[ie]+';\fP
\&\fC+------+--------------+
| 2008 | Shari Trewin |
+------+--------------+\fP
.fi
.RE
The \&\fCREGEXP\fP operator can also be written
\&\fCRLIKE\fP.
.PP
Unlike normal SQL pattern matching, MySQL
regular-expression patterns can match any
substring of a value, so there is no need to
surround the pattern with \&\fC.*\fP to force a
match against the entire string value.
.PP
To list the column fields in the MySQL database,
and to get further help, use the commands
.RS
.nf
.B "describe bibtab;"
.B "help"
.BI "help" " command"
.fi
.RE
.PP
MySQL normally prints a timing report after the
output of each command.  You can get detailed
performance reports for queries with the MySQL
profiling feature.  Turn on profiling, run one or
more commands, list their query numbers, and then
request a report on a particular one:
.RS
.nf
.B "set profiling = 1;"
.B ".\|.\|. arbitrary commands here .\|.\|."
.B "show profiles;"
.B "show profile for query 2;"
.fi
.RE
.PP
Besides the many books listed in the
\&\fCsqlbooks\fP bibliography cited earlier,
extensive documentation about MySQL can be found
at its Web site:
.RS
.nf
\&\fChttp://dev.mysql.com/doc/#manual\fP
.br
\&\fChttp://downloads.mysql.com/docs/\fP
.br
\&\fChttp://dev.mysql.com/doc/refman/5.1/en/faqs.html\fP
.fi
.RE
.\"=====================================================================
.SH "PostgreSQL NOTES"
Like MySQL, PostgreSQL is also a client/server
system, and has similar problems of considerable
management complexity.  The human software
installer needs to customize the
.B bibsql
shell script to meet local conventions for
connecting SQL clients to their servers.  However,
users of the script need not be concerned with
those issues.
.PP
All of the SQLite command examples also work in
PostgreSQL, except that the SQLite \&\fCGLOB\fP
command is not supported in PostgreSQL, and the
\&\fCLIKE\fP operator does
.I not
ignore lettercase.
.PP
Conventional Unix-style regular-expression
matching is available in PostgreSQL with the tilde
operator, like this:
.RS
.nf
 \&\fBselect year, author from bibtab where author ~ 'Sh[ae]r[ie]+';\fP
\&\fC year |    author
------+--------------
 2008 | Shari Trewin
(1 row)\fP
.fi
.RE
Matching with the tilde operator is lettercase
sensitive.  Use the companion tilde-star,
\&\fC~*\fP, operator for matching with lettercase
ignored.
.PP
Unlike normal SQL pattern matching, PostgreSQL
regular-expression patterns can match any
substring of a value, so there is no need to
surround the pattern with \&\fC.*\fP to force a
match against the entire string value.
.PP
The output format can be changed with the help of
two PostgreSQL commands:
.RS
.\" .TP \w'\fI\epset format\fP'u+3n
.TP 0.75i
.BI "\epset format" " unaligned | aligned | html | latex | troff-ms"
The default mode is
.IR aligned ,
as in the preceding search example.
.IP
The
.I unaligned
option produces data separated by the current
field separator (set by the \&\fC\ef\fP command,
with a default of a vertical bar).
.IP
The other formats produce data suitable for
embedding in other documents in the indicated
languages.  The output data in those formats have
insufficient surrounding markup to be used as
standalone documents.
.TP
.BI "\epset border" " 0 | 1 | 2"
Border style 0 replaces the field separator with
whitespace between cell values.  Border style 1 is
the default, and uses the field separator.  Border
style 2 produces additional boxing around the
output table.
.RE
.PP
Get further help with these commands:
.RS
.nf
.B "\e?"
.B "\eh"
.BI "\eh" " command"
.fi
.RE
.PP
List the column fields in a PostgreSQL table:
.RS
.nf
\&\fB\ed strtab\fP
\&\fC key    | text |
 value  | text |
 entry  | text | not null\fP
.fi
.RE
.PP
List available databases:
.RS
.nf
.B "\el"
\&\fC        List of databases
   Name    |  Owner   | Encoding
-----------+----------+----------
 bibtex    | bibtex   | UTF8
 postgres  | postgres | UTF8
 template0 | postgres | UTF8
 template1 | postgres | UTF8
 test      | postgres | UTF8\fP
.fi
.RE
.PP
List database users and their permissions:
.RS
.nf
\&\fB\edu\fP
\&\fC                               List of roles
 Role name | Superuser | Create role | Create DB | Connections | Member of
-----------+-----------+-------------+-----------+-------------+-----------
 anonymous | no        | no          | no        | no limit    | {}
 bibtex    | no        | no          | yes       | no limit    | {}
 postgres  | yes       | yes         | yes       | no limit    | {}\fP
.fi
.RE
.PP
Find the type and number of arguments accepted by
a build-in function:
.RS
.nf
\&\fB\eda avg\fP
\&\fC                       List of aggregate functions
   Schema   | Name | Result data type | Argument data types | Description
------------+------+------------------+---------------------+-------------
 pg_catalog | avg  | double precision | real                |
 pg_catalog | avg  | double precision | double precision    |
 pg_catalog | avg  | interval         | interval            |
 pg_catalog | avg  | numeric          | bigint              |
 pg_catalog | avg  | numeric          | numeric             |
 pg_catalog | avg  | numeric          | integer             |
 pg_catalog | avg  | numeric          | smallint            |\fP
.fi
.RE
.PP
Toggle command timing on or off:
.RS
.nf
.B "\etiming"
.fi
.RE
.PP
Besides the many books listed in the
\&\fCsqlbooks\fP bibliography cited earlier,
extensive documentation about PostgreSQL can be
found at its Web site:
.RS
.nf
\&\fChttp://www.postgresql.org/docs/manuals/\fP
.br
\&\fChttp://www.postgresql.org/files/documentation/pdf/\fP
.br
\&\fChttp://www.postgresql.org/docs/faqs.FAQ.html\fP
.fi
.RE
.\"=====================================================================
.SH "CAVEATS"
SQL has dozens of commands and many powerful
expression features that we have not mentioned
here.
.B bibsql
completes its job by starting the requested, or
default, SQL client program, and does
.I no
input filtering whatsoever.  The full power of SQL
is therefore available to the knowledgeable user.
Because some SQL commands can alter or destroy
data, or add new data, the shared database itself
should be made
.IR read-only .
It is recommended that database updates be allowed
only for one or more local database
administrators.
.PP
At sites with active \*(Bi\& files, it may be
helpful to install an automated job that updates
the master database at suitable intervals from
lists of \*(Bi\& directories or files.
.\"=====================================================================
.SH FILES
.B bibsql
has no files of its own.  The SQL database system
manages the bibliographic data, which is
.I read-only
for
.B bibsql
users.  However, each of the supported database
systems normally records a command history file in
the user's home directory that may be a useful
record of past SQL activity:
.RS
.TP \w'\fC$HOME/.sqlite_history\fP'u+3n
\&\fC$HOME/.mysql_history\fP
MySQL command history file
.TP
\&\fC$HOME/.psql_history\fP
PostgreSQL command history file
.TP
\&\fC$HOME/.sqlite_history\fP
SQLite command history file
.RE
.PP
The history file is loaded when the SQL client
starts, so commands from previous sessions are
readily available.  Use the up and down arrow
keys, or control keys C-p and C-n, to navigate in
the history list.  Use left and right arrow keys,
or control keys C-f and C-b, to move within a
single line.  The DELete and Backspace keys delete
backward, and the control key C-d deletes forward.
C-u erase to beginning of line, and C-k erases to
end of line, both from the current position.
Typing ordinary characters inserts them in the
line, and a RETurn key executes the command on the
current line.
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe
University of Utah
Department of Mathematics, 110 LCB
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Tel: +1 801 581 5254
FAX: +1 801 581 4148
Email: \&\fCbeebe@math.utah.edu\fP, \&\fCbeebe@acm.org\fP, \&\fCbeebe@computer.org\fP (Internet)
URL: \&\fChttp://www.math.utah.edu/~beebe\fP
.fi
.PP
The master archive for the
.B bibsql
and
.BR bibtosql (1)
software is at these equivalent locations:
.RS
.nf
\&\fCftp://ftp.math.utah.edu/pub/tex/bibsql\fP
.br
\&\fChttp://www.math.utah.edu/pub/tex/bibsql\fP
.fi
.RE
.\"=====================================================================
.SH "SEE ALSO"
.BR bib2xml (1),
.BR bib2xtx (1),
.BR bibcheck (1),
.BR bibclean (1),
.BR bibdestringify (1),
.BR bibdup (1),
.BR bibextract (1),
.BR bibindex (1),
.BR bibjoin (1),
.BR biblabel (1),
.BR biblex (1),
.BR biblook (1),
.BR biborder (1),
.BR bibparse (1),
.BR bibsearch (1),
.BR bibsort (1),
.BR bibsplit (1),
.BR bibtex (1),
.BR bibtosql (1),
.BR bibunlex (1),
.BR cattobib (1),
.BR citefind (1),
.BR citesub (1),
.BR citetags (1),
.BR date (1),
.BR latex (1),
.BR mysql (1),
.BR psql (1),
.BR ref2bib (1),
.BR scribe (1),
.BR sqlite3 (1),
.BR tex (1),
.BR xml2bib (1),
.BR xml2wordbib (1),
.BR xtx2bib (1).
.\"=====================================================================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
